VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWinVersion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
'Autor :  Stefan Maag

' ***************************************************************************
'  Diese Klasse ermittelt den Typ, die Version von Windows
' ***************************************************************************

'     Autor :  Stefan Maag       26/09/2001


' ===========================================================================
'  Quellenangaben:
' ===========================================================================

'    1: www.activevb.de - Tips und Tricks
'       Tip129: laufendes Betriebsystem ermitteln

'    2: WIN32 API - Klaus Prinz - Verlag: Addison Wesley, ISBN 3 8273 1720 7
'    3: MSDN Library Juli 2001, Microsoft

' ===========================================================================
'  Weitere bentigte Klassen:
' ===========================================================================
'     !keine

Option Explicit

' Aufzhlungstyp der Windwos Versionen
Public Enum eOSVersion
   unknown = 0
   Win32s = 1
   Win95 = 2
   Win98 = 3
   Win98SE = 4
   WinME = 5
   WinNT = 6
   Win2000 = 7
   WinXP = 8
End Enum

Private Declare Function GetVersionEx Lib "kernel32" Alias _
        "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
End Type

Const VER_PLATFORM_WIN32s = 0
Const VER_PLATFORM_WIN32_WINDOWS = 1
Const VER_PLATFORM_WIN32_NT = 2

Dim OSInfo As OSVERSIONINFO            ' Windows-Versions-Informationen
Dim OSName As String                   ' Windows-Name z.B. "Windows 95"
Dim OSVersionType As eOSVersion        ' WindowsVersion als nummerischer Aufzhlungwert


' ===========================================================================
'      WindowsName ausgeben
' ===========================================================================

Public Property Get WindowsName() As String
   WindowsName = OSName
End Property

' ===========================================================================
'      WindowsVersion als aufzhlungskonstante ausgeben
' ===========================================================================

Public Property Get WindowsVersion() As eOSVersion
   WindowsVersion = OSVersionType
End Property

' ===========================================================================
'   Eigenschaften fr einzelene Windows-Versionen als Boolsche Rckgabe
' ===========================================================================

Public Property Get Windows95() As Boolean
   Windows95 = (OSVersionType = Win95)
End Property

Public Property Get Windows98() As Boolean
   Windows98 = (OSVersionType = Win98 Or OSVersionType = Win98SE)
End Property

Public Property Get WindowsME() As Boolean
   WindowsME = (OSVersionType = WinME)
End Property

Public Property Get WindowsNT() As Boolean
   WindowsNT = (OSVersionType = WinNT)
End Property

Public Property Get Windows2000() As Boolean
   Windows2000 = (OSVersionType = Win2000)
End Property

Public Property Get WindowsXP() As Boolean
   WindowsXP = (OSVersionType = WinXP)
End Property

' gibt True aus fr alle NT-Plattformen (NT , Win2K, WinXP )
Public Property Get IsNtPlattform() As Boolean
   IsNtPlattform = (OSInfo.dwPlatformId = VER_PLATFORM_WIN32_NT)
End Property

' ===========================================================================
'   spezielle Informationen fr NT-Plattformen
' ===========================================================================

Public Property Get ServicePack() As String
   ServicePack = OSInfo.szCSDVersion
End Property

Public Property Get NTVersion() As Long
    If OSInfo.dwPlatformId = VER_PLATFORM_WIN32_NT Then
        NTVersion = OSInfo.dwMajorVersion
    End If
End Property

' ===========================================================================
'       Klasse intialisieren: Windows-Versions-Informationen lesen
' ===========================================================================

Private Sub Class_Initialize()
   
   OSInfo.dwOSVersionInfoSize = Len(OSInfo)
   Call GetVersionEx(OSInfo)
   
   GetOSName                  ' WindowsNamen bestimmen
   
End Sub

' ===========================================================================
'      Windows-Namen ermitteln
' ===========================================================================

Private Sub GetOSName()
   
   Dim BuildNr As Long
   
   OSName = "unknown operating system"
   OSVersionType = unknown
   
   With OSInfo
      
      If (.dwBuildNumber And &HFFFF&) > &H7FFF Then
        BuildNr = (.dwBuildNumber And &HFFFF&) - &H10000
      Else
        BuildNr = .dwBuildNumber And &HFFFF&
      End If
      
      
      Select Case .dwPlatformId
         
         ' ---------------------------------------------------------------
         '  Windows NT / 2000 / XP
         ' ---------------------------------------------------------------
         Case VER_PLATFORM_WIN32_NT
        
            If .dwMajorVersion = 4 Then
               OSName = "Windows NT"
               OSVersionType = WinNT
               
            ElseIf .dwMajorVersion = 5 Then
               OSName = "Windows 2000"
               OSVersionType = Win2000
            
            ElseIf .dwMajorVersion = 6 Then     ' ! noch nicht getestet
               OSName = "Windows XP"
               OSVersionType = WinXP
            
            End If
         
         ' ---------------------------------------------------------------
         '  Windows 95/98/ME
         ' ---------------------------------------------------------------
         Case VER_PLATFORM_WIN32_WINDOWS
        
            If (.dwMajorVersion = 4 And .dwMinorVersion = 0) Then
               OSName = "Windows 95"
               OSVersionType = Win95
            
            ElseIf (.dwMajorVersion = 4 And .dwMinorVersion = 10) Then
              
               If BuildNr = 1998 Then
                  OSName = "Windows 98"
                  OSVersionType = Win98
               Else
                  OSName = "Windows 98 SE"
                  OSVersionType = Win98SE
               End If
            
               
            ElseIf (.dwMajorVersion = 4 And .dwMinorVersion = 90) Then
               OSName = "Windows ME"
               OSVersionType = WinME
            End If
      
         ' ---------------------------------------------------------------
         '  WIN 3.11 mit Win32s
         ' ---------------------------------------------------------------
         Case VER_PLATFORM_WIN32s
            OSName = "Windows 32s"
            OSVersionType = Win32s
      
      End Select
   End With
End Sub

